'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _babblerScriptJs = require('babbler-script-js');

var _babblerScriptJs2 = _interopRequireDefault(_babblerScriptJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// BabblerScriptProgram.js

var React = require('react');

//import BabblerScript from '../../babbler-script-js/src/babbler-script';

// Псевдо-элементы CSS :before и :after не получится использовать напрямую
// из инлайн-стилей React, поэтому придется немного покосоручить
// https://stackoverflow.com/questions/27530462/react-jsx-style-tag-error-on-render
// https://css-tricks.com/examples/ShapesOfCSS/
// http://www.webgranth.com/css-borders-create-border-and-shapes-with-css
// https://css-tricks.com/snippets/css/css-triangle/

// треугольничек справа от номера исполняемой строки
var css = '\n.currLineNumber:after {\n  position: absolute;\n  content: \'\';\n  width: 0;\n  height: 0;\n  border-top: 10px solid transparent;\n  border-bottom: 10px solid transparent;\n  border-left: 10px solid #5599ff;\n}\n';
var lineStyle = {
    width: '100%',
    fontSize: 16
};

var currLineStyle = _extends({}, lineStyle, {
    backgroundColor: '#ffeeaa'
});

var lineNumberStyle = {
    color: 'white',
    backgroundColor: '#5599ff',
    width: 1,
    fontSize: 12,
    textAlign: 'right',
    verticalAlign: 'middle',
    padding: 3,
    paddingLeft: 5,
    paddingRight: 5
};

var currLineNumberStyle = _extends({}, lineNumberStyle);

var cmdCellStyle = {};

var currCmdCellStyle = _extends({}, cmdCellStyle);

var cmdStyle = {
    color: "#164450",
    fontWeight: 'bold',
    paddingLeft: 10
};

var currCmdStyle = _extends({}, cmdStyle);

var paramsStyle = {
    color: "#d400aa",
    paddingLeft: 10
};

var currParamsStyle = _extends({}, paramsStyle);

// Программа - скрипт BabblerScript
var BabblerScriptProgram = React.createClass({
    displayName: 'BabblerScriptProgram',

    // http://www.material-ui.com/#/components/table

    getInitialState: function getInitialState() {
        return {
            program: this.props.babblerScript.program,
            pc: this.props.babblerScript.programCounter
        };
    },

    componentDidMount: function componentDidMount() {
        this.programListener = function (prog) {
            this.setState({ program: prog });
        }.bind(this);
        this.programCounterListener = function (pc) {
            this.setState({ pc: pc });
        }.bind(this);

        this.props.babblerScript.on(_babblerScriptJs2.default.Event.PROGRAM, this.programListener);
        this.props.babblerScript.on(_babblerScriptJs2.default.Event.PROGRAM_COUNTER, this.programCounterListener);
    },

    componentWillUnmount: function componentWillUnmount() {
        // почистим слушателей
        this.props.babblerScript.removeListener(_babblerScriptJs2.default.Event.PROGRAM, this.programListener);
        this.props.babblerScript.removeListener(_babblerScriptJs2.default.Event.PROGRAM_COUNTER, this.programCounterListener);
    },

    render: function render() {
        var progLines = [];

        // добавим одну пустую нулевую строку (pc=-1), чтобы обозначить, что
        // программа готова к старту
        var currLine = -1 == this.state.pc;
        progLines.push(React.createElement(
            'div',
            { key: -1,
                style: _extends({ display: 'table-row' }, currLine ? currLineStyle : lineStyle) },
            React.createElement('div', { style: _extends({ display: 'table-cell', height: 26 }, currLine ? currLineNumberStyle : lineNumberStyle),
                className: currLine ? "currLineNumber" : "" }),
            React.createElement('div', { style: _extends({ display: 'table-cell' }, currLine ? currCmdCellStyle : cmdCellStyle) })
        ));

        for (var i = 0; i < this.state.program.length; i++) {
            var paramsSeg = [];
            for (var j = 0; j < this.state.program[i].params.length; j++) {
                paramsSeg.push(" " + this.state.program[i].params[j]);
            }

            currLine = i == this.state.pc;

            var lineElem = React.createElement(
                'div',
                { key: i,
                    style: _extends({ display: 'table-row' }, currLine ? currLineStyle : lineStyle) },
                React.createElement(
                    'div',
                    { style: _extends({ display: 'table-cell' }, currLine ? currLineNumberStyle : lineNumberStyle),
                        className: currLine ? "currLineNumber" : "" },
                    i + 1
                ),
                React.createElement(
                    'div',
                    { style: _extends({ display: 'table-cell' }, currLine ? currCmdCellStyle : cmdCellStyle) },
                    React.createElement(
                        'span',
                        { style: currLine ? currCmdStyle : cmdStyle },
                        this.state.program[i].cmd
                    ),
                    React.createElement(
                        'span',
                        { style: currLine ? currParamsStyle : paramsStyle },
                        paramsSeg
                    )
                )
            );

            progLines.push(lineElem);
        }

        return React.createElement(
            'div',
            { style: _extends({ display: 'table' }, this.props.style) },
            React.createElement(
                'style',
                null,
                css
            ),
            progLines
        );
    }
});

// отправляем компонент на публику
module.exports = BabblerScriptProgram;